#include "PicoGraphLib.h"

extern volatile union
{
	uint8_t volatile OneDimension_8[ROW_VIDEO_BUFF_SIZE * COL_VIDEO_BUFF_SIZE*2];
	uint8_t volatile TwoDimension_8[ROW_VIDEO_BUFF_SIZE][COL_VIDEO_BUFF_SIZE*2];
//	uint32_t volatile HalfDimension[ROW_VIDEO_BUFF_SIZE * COL_VIDEO_BUFF_SIZE / (sizeof(uint32_t)/sizeof(buff_t))];
	buff_t volatile OneDimension[ROW_VIDEO_BUFF_SIZE * COL_VIDEO_BUFF_SIZE];
	buff_t volatile TwoDimension[ROW_VIDEO_BUFF_SIZE][COL_VIDEO_BUFF_SIZE];
} VideoBuff;

void UG_DrawLine( UG_S16 x1, UG_S16 y1, UG_S16 x2, UG_S16 y2, UG_COLOR c )
{
	UG_S16 n, dx, dy, sgndx, sgndy, dxabs, dyabs, x, y, drawx, drawy;

//	if ( x2 < x1 )
//	{
//		n = x2;
//		x2 = x1;
//		x1 = n;
//	}
//	if ( y2 < y1 )
//	{
//		n = y2;
//		y2 = y1;
//		y1 = n;
//	}

	/* Is hardware acceleration available? */
//	if ( gui->driver[DRIVER_DRAW_LINE].state & DRIVER_ENABLED )
//	{
//		if( ((UG_RESULT(*)(UG_S16 x1, UG_S16 y1, UG_S16 x2, UG_S16 y2, UG_COLOR c))gui->driver[DRIVER_DRAW_LINE].driver)(x1,y1,x2,y2,c) == UG_RESULT_OK ) return;
//	}

	dx = x2 - x1;
	dy = y2 - y1;
	dxabs = (dx>0)?dx:-dx;
	dyabs = (dy>0)?dy:-dy;
	sgndx = (dx>0)?1:-1;
	sgndy = (dy>0)?1:-1;
	x = dyabs >> 1;
	y = dxabs >> 1;
	drawx = x1;
	drawy = y1;

	DrawPixel(drawx, drawy,c);

	if( dxabs >= dyabs )
	{
		for( n=0; n<dxabs; n++ )
		{
			y += dyabs;
			if( y >= dxabs )
			{
				y -= dxabs;
				drawy += sgndy;
			}
			drawx += sgndx;
			DrawPixel(drawx, drawy,c);
		}
	}
	else
	{
		for( n=0; n < dyabs; n++ )
		{
			x += dxabs;
			if( x >= dyabs )
			{
				x -= dyabs;
				drawx += sgndx;
			}
			drawy += sgndy;
			DrawPixel(drawx, drawy,c);
		}
	}
}


void DrawPixel(int16_t x, int16_t y, UG_COLOR color)
{
	int16_t colBlock = x/16 * 3;
//	int16_t colBlock = (x & 0x00F0) * 3;
	int16_t colBlockDelta = x & 0x000F;	//x % 16;
	
	switch(colBlockDelta)
	{
		case  0:
		VideoBuff.TwoDimension[y][colBlock + ARR_BLOCK_0] &= ~(COLOR_ERRASER << 13);
		VideoBuff.TwoDimension[y][colBlock + ARR_BLOCK_0] |= color << 13;
		break;
		
		case  1:
		VideoBuff.TwoDimension[y][colBlock + ARR_BLOCK_0] &= ~(COLOR_ERRASER << 10);
		VideoBuff.TwoDimension[y][colBlock + ARR_BLOCK_0] |= color << 10;
		break;
		
		case  2:
		VideoBuff.TwoDimension[y][colBlock + ARR_BLOCK_0] &= ~(COLOR_ERRASER << 7);
		VideoBuff.TwoDimension[y][colBlock + ARR_BLOCK_0] |= color << 7;
		break;
		
		case  3:
		VideoBuff.TwoDimension[y][colBlock + ARR_BLOCK_0] &= ~(COLOR_ERRASER << 4);
		VideoBuff.TwoDimension[y][colBlock + ARR_BLOCK_0] |= color << 4;
		break;
		
		case  4:
		VideoBuff.TwoDimension[y][colBlock + ARR_BLOCK_0] &= ~(COLOR_ERRASER << 1);
		VideoBuff.TwoDimension[y][colBlock + ARR_BLOCK_0] |= color << 1;
		break;
		
		case  5:
		VideoBuff.TwoDimension[y][colBlock + ARR_BLOCK_0] &= ~(COLOR_ERRASER >> 2);
		VideoBuff.TwoDimension[y][colBlock + ARR_BLOCK_1] &= ~(COLOR_ERRASER << 14);
		VideoBuff.TwoDimension[y][colBlock + ARR_BLOCK_0] |= color >> 2;
		VideoBuff.TwoDimension[y][colBlock + ARR_BLOCK_1] |= color << 14;
		break;
		
		case  6:
		VideoBuff.TwoDimension[y][colBlock + ARR_BLOCK_1] &= ~(COLOR_ERRASER << 11);
		VideoBuff.TwoDimension[y][colBlock + ARR_BLOCK_1] |= color << 11;
		break;
		
		case  7:
		VideoBuff.TwoDimension[y][colBlock + ARR_BLOCK_1] &= ~(COLOR_ERRASER << 8);
		VideoBuff.TwoDimension[y][colBlock + ARR_BLOCK_1] |= color << 8;
		break;
		
		case  8:
		VideoBuff.TwoDimension[y][colBlock + ARR_BLOCK_1] &= ~(COLOR_ERRASER << 5);
		VideoBuff.TwoDimension[y][colBlock + ARR_BLOCK_1] |= color << 5;
		break;
		
		case  9:
		VideoBuff.TwoDimension[y][colBlock + ARR_BLOCK_1] &= ~(COLOR_ERRASER << 2);
		VideoBuff.TwoDimension[y][colBlock + ARR_BLOCK_1] |= color << 2;
		break;
		
		case  10:
		VideoBuff.TwoDimension[y][colBlock + ARR_BLOCK_1] &= ~(COLOR_ERRASER >> 1);
		VideoBuff.TwoDimension[y][colBlock + ARR_BLOCK_2] &= ~(COLOR_ERRASER << 15);
		VideoBuff.TwoDimension[y][colBlock + ARR_BLOCK_1] |= color >> 1;
		VideoBuff.TwoDimension[y][colBlock + ARR_BLOCK_2] |= color << 15;
		break;
		
		case  11:
		VideoBuff.TwoDimension[y][colBlock + ARR_BLOCK_2] &= ~(COLOR_ERRASER << 12);
		VideoBuff.TwoDimension[y][colBlock + ARR_BLOCK_2] |= color << 12;
		break;
		
		case  12:
		VideoBuff.TwoDimension[y][colBlock + ARR_BLOCK_2] &= ~(COLOR_ERRASER << 9);
		VideoBuff.TwoDimension[y][colBlock + ARR_BLOCK_2] |= color << 9;
		break;
		
		case  13:
		VideoBuff.TwoDimension[y][colBlock + ARR_BLOCK_2] &= ~(COLOR_ERRASER << 6);
		VideoBuff.TwoDimension[y][colBlock + ARR_BLOCK_2] |= color << 6;
		break;
		
		case  14:
		VideoBuff.TwoDimension[y][colBlock + ARR_BLOCK_2] &= ~(COLOR_ERRASER << 3);
		VideoBuff.TwoDimension[y][colBlock + ARR_BLOCK_2] |= color << 3;
		break;
		
		case  15:
		VideoBuff.TwoDimension[y][colBlock + ARR_BLOCK_2] &= ~COLOR_ERRASER;
		VideoBuff.TwoDimension[y][colBlock + ARR_BLOCK_2] |= color;
		break;
		
		default:
		break;
	}
}

void _UG_PutChar( char chr, UG_S16 x, UG_S16 y, UG_COLOR fc, UG_COLOR bc, const UG_FONT* font)
{
	UG_U16 i,j,k,xo,yo,c,bn,actual_char_width;
	UG_U8 b,bt;
	UG_U32 index;
	UG_COLOR color;
	void(*push_pixel)(UG_COLOR);

	bt = (UG_U8)chr;

	switch ( bt )
	{
		case 0xF6: bt = 0x94; break; //
		case 0xD6: bt = 0x99; break; //
		case 0xFC: bt = 0x81; break; //
		case 0xDC: bt = 0x9A; break; //
		case 0xE4: bt = 0x84; break; //
		case 0xC4: bt = 0x8E; break; //
		case 0xB5: bt = 0xE6; break; //
		case 0xB0: bt = 0xF8; break; //
	}

	if (bt < font->start_char || bt > font->end_char) return;

	yo = y;
	bn = font->char_width;
	if ( !bn ) return;
	bn >>= 3;
	if ( font->char_width % 8 ) bn++;
	actual_char_width = (font->widths ? font->widths[bt - font->start_char] : font->char_width);

	/*Not accelerated output*/
	if (font->font_type == FONT_TYPE_1BPP)
	{
	 index = (bt - font->start_char)* font->char_height * bn;
	 for( j=0;j<font->char_height;j++ )
	 {
	   xo = x;
	   c=actual_char_width;
	   for( i=0;i<bn;i++ )
	   {
		 b = font->p[index++];
		 for( k=0;(k<8) && c;k++ )
		 {
		   if( b & 0x01 )
		   {
			   DrawPixel(xo,yo,fc); //gui->pset(xo,yo,fc);
		   }
		   else
		   {
			   DrawPixel(xo,yo,bc); //gui->pset(xo,yo,bc);
		   }
		   b >>= 1;
		   xo++;
		   c--;
		 }
	   }
	   yo++;
	 }
	}
	else if (font->font_type == FONT_TYPE_8BPP)
	{
	 index = (bt - font->start_char)* font->char_height * font->char_width;
	 for( j=0;j<font->char_height;j++ )
	 {
		xo = x;
		for( i=0;i<actual_char_width;i++ )
		{
		   b = font->p[index++];
		   color = (((fc & 0xFF) * b + (bc & 0xFF) * (256 - b)) >> 8) & 0xFF |//Blue component
				   (((fc & 0xFF00) * b + (bc & 0xFF00) * (256 - b)) >> 8)  & 0xFF00|//Green component
				   (((fc & 0xFF0000) * b + (bc & 0xFF0000) * (256 - b)) >> 8) & 0xFF0000; //Red component
		   DrawPixel(xo,yo,color);//gui->pset(xo,yo,color);
		   xo++;
		}
		index += font->char_width - actual_char_width;
		yo++;
	 }
	}
}


#ifdef USE_FONT_6X8
const unsigned char font_6x8[256][8]={
{0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00},   // 0x00
{0x1C,0x22,0x36,0x22,0x2A,0x22,0x1C,0x00},   // 0x01
{0x1C,0x3E,0x2A,0x3E,0x22,0x3E,0x1C,0x00},   // 0x02
{0x00,0x14,0x3E,0x3E,0x3E,0x1C,0x08,0x00},   // 0x03
{0x00,0x08,0x1C,0x3E,0x3E,0x1C,0x08,0x00},   // 0x04
{0x08,0x1C,0x1C,0x08,0x3E,0x3E,0x08,0x00},   // 0x05
{0x00,0x08,0x1C,0x3E,0x3E,0x08,0x1C,0x00},   // 0x06
{0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00},   // 0x07
{0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00},   // 0x08
{0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00},   // 0x09
{0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00},   // 0x0A
{0x00,0x38,0x30,0x2C,0x12,0x12,0x0C,0x00},   // 0x0B
{0x1C,0x22,0x22,0x1C,0x08,0x1C,0x08,0x00},   // 0x0C
{0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00},   // 0x0D
{0x30,0x2C,0x34,0x2C,0x34,0x36,0x06,0x00},   // 0x0E
{0x00,0x2A,0x1C,0x36,0x1C,0x2A,0x00,0x00},   // 0x0F
{0x04,0x0C,0x1C,0x3C,0x1C,0x0C,0x04,0x00},   // 0x10
{0x10,0x18,0x1C,0x1E,0x1C,0x18,0x10,0x00},   // 0x11
{0x08,0x1C,0x3E,0x08,0x3E,0x1C,0x08,0x00},   // 0x12
{0x14,0x14,0x14,0x14,0x14,0x00,0x14,0x00},   // 0x13
{0x3C,0x2A,0x2A,0x2C,0x28,0x28,0x28,0x00},   // 0x14
{0x1C,0x22,0x0C,0x14,0x18,0x22,0x1C,0x00},   // 0x15
{0x00,0x00,0x00,0x00,0x00,0x1E,0x1E,0x00},   // 0x16
{0x08,0x1C,0x3E,0x08,0x3E,0x1C,0x08,0x1C},   // 0x17
{0x08,0x1C,0x3E,0x08,0x08,0x08,0x08,0x00},   // 0x18
{0x08,0x08,0x08,0x08,0x3E,0x1C,0x08,0x00},   // 0x19
{0x00,0x08,0x18,0x3E,0x18,0x08,0x00,0x00},   // 0x1A
{0x00,0x08,0x0C,0x3E,0x0C,0x08,0x00,0x00},   // 0x1B
{0x00,0x00,0x00,0x02,0x02,0x02,0x3E,0x00},   // 0x1C
{0x00,0x14,0x14,0x3E,0x14,0x14,0x00,0x00},   // 0x1D
{0x08,0x08,0x1C,0x1C,0x3E,0x3E,0x00,0x00},   // 0x1E
{0x3E,0x3E,0x1C,0x1C,0x08,0x08,0x00,0x00},   // 0x1F
{0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00},   // 0x20
{0x08,0x1C,0x1C,0x08,0x08,0x00,0x08,0x00},   // 0x21
{0x36,0x36,0x12,0x00,0x00,0x00,0x00,0x00},   // 0x22
{0x00,0x14,0x3E,0x14,0x14,0x3E,0x14,0x00},   // 0x23
{0x04,0x1C,0x02,0x0C,0x10,0x0E,0x08,0x00},   // 0x24
{0x26,0x26,0x10,0x08,0x04,0x32,0x32,0x00},   // 0x25
{0x04,0x0A,0x0A,0x04,0x2A,0x12,0x2C,0x00},   // 0x26
{0x0C,0x0C,0x04,0x00,0x00,0x00,0x00,0x00},   // 0x27
{0x08,0x04,0x04,0x04,0x04,0x04,0x08,0x00},   // 0x28
{0x04,0x08,0x08,0x08,0x08,0x08,0x04,0x00},   // 0x29
{0x00,0x14,0x1C,0x3E,0x1C,0x14,0x00,0x00},   // 0x2A
{0x00,0x08,0x08,0x3E,0x08,0x08,0x00,0x00},   // 0x2B
{0x00,0x00,0x00,0x00,0x00,0x0C,0x0C,0x04},   // 0x2C
{0x00,0x00,0x00,0x3E,0x00,0x00,0x00,0x00},   // 0x2D
{0x00,0x00,0x00,0x00,0x00,0x0C,0x0C,0x00},   // 0x2E
{0x00,0x20,0x10,0x08,0x04,0x02,0x00,0x00},   // 0x2F
{0x1C,0x22,0x32,0x2A,0x26,0x22,0x1C,0x00},   // 0x30
{0x08,0x0C,0x08,0x08,0x08,0x08,0x1C,0x00},   // 0x31
{0x1C,0x22,0x20,0x18,0x04,0x02,0x3E,0x00},   // 0x32
{0x1C,0x22,0x20,0x1C,0x20,0x22,0x1C,0x00},   // 0x33
{0x10,0x18,0x14,0x12,0x3E,0x10,0x10,0x00},   // 0x34
{0x3E,0x02,0x02,0x1E,0x20,0x22,0x1C,0x00},   // 0x35
{0x18,0x04,0x02,0x1E,0x22,0x22,0x1C,0x00},   // 0x36
{0x3E,0x20,0x10,0x08,0x04,0x04,0x04,0x00},   // 0x37
{0x1C,0x22,0x22,0x1C,0x22,0x22,0x1C,0x00},   // 0x38
{0x1C,0x22,0x22,0x3C,0x20,0x10,0x0C,0x00},   // 0x39
{0x00,0x00,0x0C,0x0C,0x00,0x0C,0x0C,0x00},   // 0x3A
{0x00,0x00,0x0C,0x0C,0x00,0x0C,0x0C,0x04},   // 0x3B
{0x10,0x08,0x04,0x02,0x04,0x08,0x10,0x00},   // 0x3C
{0x00,0x00,0x3E,0x00,0x00,0x3E,0x00,0x00},   // 0x3D
{0x04,0x08,0x10,0x20,0x10,0x08,0x04,0x00},   // 0x3E
{0x1C,0x22,0x20,0x18,0x08,0x00,0x08,0x00},   // 0x3F
{0x1C,0x22,0x3A,0x2A,0x3A,0x02,0x1C,0x00},   // 0x40
{0x1C,0x22,0x22,0x22,0x3E,0x22,0x22,0x00},   // 0x41
{0x1E,0x22,0x22,0x1E,0x22,0x22,0x1E,0x00},   // 0x42
{0x1C,0x22,0x02,0x02,0x02,0x22,0x1C,0x00},   // 0x43
{0x1E,0x22,0x22,0x22,0x22,0x22,0x1E,0x00},   // 0x44
{0x3E,0x02,0x02,0x1E,0x02,0x02,0x3E,0x00},   // 0x45
{0x3E,0x02,0x02,0x1E,0x02,0x02,0x02,0x00},   // 0x46
{0x1C,0x22,0x02,0x3A,0x22,0x22,0x3C,0x00},   // 0x47
{0x22,0x22,0x22,0x3E,0x22,0x22,0x22,0x00},   // 0x48
{0x1C,0x08,0x08,0x08,0x08,0x08,0x1C,0x00},   // 0x49
{0x20,0x20,0x20,0x20,0x22,0x22,0x1C,0x00},   // 0x4A
{0x22,0x12,0x0A,0x06,0x0A,0x12,0x22,0x00},   // 0x4B
{0x02,0x02,0x02,0x02,0x02,0x02,0x3E,0x00},   // 0x4C
{0x22,0x36,0x2A,0x22,0x22,0x22,0x22,0x00},   // 0x4D
{0x22,0x26,0x2A,0x32,0x22,0x22,0x22,0x00},   // 0x4E
{0x1C,0x22,0x22,0x22,0x22,0x22,0x1C,0x00},   // 0x4F
{0x1E,0x22,0x22,0x1E,0x02,0x02,0x02,0x00},   // 0x50
{0x1C,0x22,0x22,0x22,0x2A,0x12,0x2C,0x00},   // 0x51
{0x1E,0x22,0x22,0x1E,0x12,0x22,0x22,0x00},   // 0x52
{0x1C,0x22,0x02,0x1C,0x20,0x22,0x1C,0x00},   // 0x53
{0x3E,0x08,0x08,0x08,0x08,0x08,0x08,0x00},   // 0x54
{0x22,0x22,0x22,0x22,0x22,0x22,0x1C,0x00},   // 0x55
{0x22,0x22,0x22,0x22,0x22,0x14,0x08,0x00},   // 0x56
{0x22,0x22,0x2A,0x2A,0x2A,0x2A,0x14,0x00},   // 0x57
{0x22,0x22,0x14,0x08,0x14,0x22,0x22,0x00},   // 0x58
{0x22,0x22,0x22,0x14,0x08,0x08,0x08,0x00},   // 0x59
{0x1E,0x10,0x08,0x04,0x02,0x02,0x1E,0x00},   // 0x5A
{0x1C,0x04,0x04,0x04,0x04,0x04,0x1C,0x00},   // 0x5B
{0x00,0x02,0x04,0x08,0x10,0x20,0x00,0x00},   // 0x5C
{0x1C,0x10,0x10,0x10,0x10,0x10,0x1C,0x00},   // 0x5D
{0x08,0x14,0x22,0x00,0x00,0x00,0x00,0x00},   // 0x5E
{0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x3F},   // 0x5F
{0x0C,0x0C,0x08,0x00,0x00,0x00,0x00,0x00},   // 0x60
{0x00,0x00,0x1C,0x20,0x3C,0x22,0x3C,0x00},   // 0x61
{0x02,0x02,0x1E,0x22,0x22,0x22,0x1E,0x00},   // 0x62
{0x00,0x00,0x1C,0x22,0x02,0x22,0x1C,0x00},   // 0x63
{0x20,0x20,0x3C,0x22,0x22,0x22,0x3C,0x00},   // 0x64
{0x00,0x00,0x1C,0x22,0x1E,0x02,0x1C,0x00},   // 0x65
{0x18,0x04,0x04,0x1E,0x04,0x04,0x04,0x00},   // 0x66
{0x00,0x00,0x3C,0x22,0x22,0x3C,0x20,0x1C},   // 0x67
{0x02,0x02,0x0E,0x12,0x12,0x12,0x12,0x00},   // 0x68
{0x08,0x00,0x08,0x08,0x08,0x08,0x18,0x00},   // 0x69
{0x10,0x00,0x18,0x10,0x10,0x10,0x12,0x0C},   // 0x6A
{0x02,0x02,0x12,0x0A,0x06,0x0A,0x12,0x00},   // 0x6B
{0x08,0x08,0x08,0x08,0x08,0x08,0x18,0x00},   // 0x6C
{0x00,0x00,0x16,0x2A,0x2A,0x22,0x22,0x00},   // 0x6D
{0x00,0x00,0x0E,0x12,0x12,0x12,0x12,0x00},   // 0x6E
{0x00,0x00,0x1C,0x22,0x22,0x22,0x1C,0x00},   // 0x6F
{0x00,0x00,0x1E,0x22,0x22,0x22,0x1E,0x02},   // 0x70
{0x00,0x00,0x3C,0x22,0x22,0x22,0x3C,0x20},   // 0x71
{0x00,0x00,0x1A,0x24,0x04,0x04,0x0E,0x00},   // 0x72
{0x00,0x00,0x1C,0x02,0x1C,0x20,0x1C,0x00},   // 0x73
{0x00,0x04,0x1E,0x04,0x04,0x14,0x08,0x00},   // 0x74
{0x00,0x00,0x12,0x12,0x12,0x1A,0x14,0x00},   // 0x75
{0x00,0x00,0x22,0x22,0x22,0x14,0x08,0x00},   // 0x76
{0x00,0x00,0x22,0x22,0x2A,0x3E,0x14,0x00},   // 0x77
{0x00,0x00,0x12,0x12,0x0C,0x12,0x12,0x00},   // 0x78
{0x00,0x00,0x12,0x12,0x12,0x1C,0x08,0x06},   // 0x79
{0x00,0x00,0x1E,0x10,0x0C,0x02,0x1E,0x00},   // 0x7A
{0x18,0x04,0x04,0x06,0x04,0x04,0x18,0x00},   // 0x7B
{0x08,0x08,0x08,0x00,0x08,0x08,0x08,0x00},   // 0x7C
{0x0C,0x10,0x10,0x30,0x10,0x10,0x0C,0x00},   // 0x7D
{0x14,0x0A,0x00,0x00,0x00,0x00,0x00,0x00},   // 0x7E
{0x08,0x1C,0x36,0x22,0x22,0x3E,0x00,0x00},   // 0x7F
{0x1C,0x22,0x02,0x02,0x22,0x1C,0x08,0x0C},   // 0x80
{0x12,0x00,0x12,0x12,0x12,0x1A,0x14,0x00},   // 0x81
{0x30,0x00,0x1C,0x22,0x1E,0x02,0x1C,0x00},   // 0x82
{0x1C,0x00,0x1C,0x20,0x3C,0x22,0x3C,0x00},   // 0x83
{0x14,0x00,0x1C,0x20,0x3C,0x22,0x3C,0x00},   // 0x84
{0x0C,0x00,0x1C,0x20,0x3C,0x22,0x3C,0x00},   // 0x85
{0x1C,0x14,0x1C,0x20,0x3C,0x22,0x3C,0x00},   // 0x86
{0x00,0x1C,0x22,0x02,0x22,0x1C,0x08,0x0C},   // 0x87
{0x1C,0x00,0x1C,0x22,0x1E,0x02,0x1C,0x00},   // 0x88
{0x14,0x00,0x1C,0x22,0x1E,0x02,0x1C,0x00},   // 0x89
{0x0C,0x00,0x1C,0x22,0x1E,0x02,0x1C,0x00},   // 0x8A
{0x14,0x00,0x08,0x08,0x08,0x08,0x18,0x00},   // 0x8B
{0x1C,0x00,0x08,0x08,0x08,0x08,0x18,0x00},   // 0x8C
{0x04,0x00,0x08,0x08,0x08,0x08,0x18,0x00},   // 0x8D
{0x14,0x00,0x08,0x14,0x22,0x3E,0x22,0x00},   // 0x8E
{0x1C,0x14,0x1C,0x36,0x22,0x3E,0x22,0x00},   // 0x8F
{0x30,0x00,0x3E,0x02,0x1E,0x02,0x3E,0x00},   // 0x90
{0x00,0x00,0x1E,0x28,0x3E,0x0A,0x3C,0x00},   // 0x91
{0x3C,0x0A,0x0A,0x3E,0x0A,0x0A,0x3A,0x00},   // 0x92
{0x1C,0x00,0x0C,0x12,0x12,0x12,0x0C,0x00},   // 0x93
{0x14,0x00,0x0C,0x12,0x12,0x12,0x0C,0x00},   // 0x94
{0x06,0x00,0x0C,0x12,0x12,0x12,0x0C,0x00},   // 0x95
{0x1C,0x00,0x12,0x12,0x12,0x1A,0x14,0x00},   // 0x96
{0x06,0x00,0x12,0x12,0x12,0x1A,0x14,0x00},   // 0x97
{0x14,0x00,0x12,0x12,0x12,0x1C,0x08,0x06},   // 0x98
{0x12,0x0C,0x12,0x12,0x12,0x12,0x0C,0x00},   // 0x99
{0x14,0x00,0x12,0x12,0x12,0x12,0x0C,0x00},   // 0x9A
{0x00,0x00,0x20,0x1C,0x1A,0x16,0x0E,0x01},   // 0x9B
{0x18,0x24,0x04,0x1E,0x04,0x24,0x3A,0x00},   // 0x9C
{0x3C,0x32,0x2A,0x2A,0x2A,0x26,0x1E,0x00},   // 0x9D
{0x00,0x22,0x14,0x08,0x14,0x22,0x00,0x00},   // 0x9E
{0x10,0x28,0x08,0x1C,0x08,0x08,0x0A,0x04},   // 0x9F
{0x18,0x00,0x1C,0x20,0x3C,0x22,0x3C,0x00},   // 0xA0
{0x18,0x00,0x08,0x08,0x08,0x08,0x18,0x00},   // 0xA1
{0x18,0x00,0x0C,0x12,0x12,0x12,0x0C,0x00},   // 0xA2
{0x18,0x00,0x12,0x12,0x12,0x1A,0x14,0x00},   // 0xA3
{0x14,0x0A,0x00,0x0E,0x12,0x12,0x12,0x00},   // 0xA4
{0x14,0x0A,0x00,0x12,0x16,0x1A,0x12,0x00},   // 0xA5
{0x1C,0x20,0x3C,0x22,0x3C,0x00,0x3C,0x00},   // 0xA6
{0x0C,0x12,0x12,0x12,0x0C,0x00,0x1E,0x00},   // 0xA7
{0x08,0x00,0x08,0x0C,0x02,0x22,0x1C,0x00},   // 0xA8
{0x1E,0x29,0x35,0x2D,0x35,0x21,0x1E,0x00},   // 0xA9
{0x00,0x00,0x3F,0x20,0x20,0x00,0x00,0x00},   // 0xAA
{0x02,0x12,0x0A,0x1C,0x22,0x10,0x38,0x00},   // 0xAB
{0x02,0x12,0x0A,0x34,0x2A,0x38,0x20,0x00},   // 0xAC
{0x08,0x00,0x08,0x08,0x1C,0x1C,0x08,0x00},   // 0xAD
{0x00,0x00,0x24,0x12,0x24,0x00,0x00,0x00},   // 0xAE
{0x00,0x00,0x12,0x24,0x12,0x00,0x00,0x00},   // 0xAF
{0x2A,0x00,0x15,0x00,0x2A,0x00,0x15,0x00},   // 0xB0
{0x2A,0x15,0x2A,0x15,0x2A,0x15,0x2A,0x15},   // 0xB1
{0x15,0x3F,0x2A,0x3F,0x15,0x3F,0x2A,0x3F},   // 0xB2
{0x08,0x08,0x08,0x08,0x08,0x08,0x08,0x08},   // 0xB3
{0x08,0x08,0x08,0x0F,0x08,0x08,0x08,0x08},   // 0xB4
{0x18,0x00,0x08,0x14,0x22,0x3E,0x22,0x00},   // 0xB5
{0x1C,0x00,0x08,0x14,0x22,0x3E,0x22,0x00},   // 0xB6
{0x0C,0x00,0x08,0x14,0x22,0x3E,0x22,0x00},   // 0xB7
{0x1E,0x21,0x2D,0x25,0x2D,0x21,0x1E,0x00},   // 0xB8
{0x0A,0x0B,0x08,0x0B,0x0A,0x0A,0x0A,0x0A},   // 0xB9
{0x0A,0x0A,0x0A,0x0A,0x0A,0x0A,0x0A,0x0A},   // 0xBA
{0x00,0x0F,0x08,0x0B,0x0A,0x0A,0x0A,0x0A},   // 0xBB
{0x0A,0x0B,0x08,0x0F,0x00,0x00,0x00,0x00},   // 0xBC
{0x00,0x08,0x1C,0x02,0x02,0x1C,0x08,0x00},   // 0xBD
{0x22,0x14,0x08,0x3E,0x08,0x3E,0x08,0x00},   // 0xBE
{0x00,0x00,0x00,0x0F,0x08,0x08,0x08,0x08},   // 0xBF
{0x08,0x08,0x08,0x38,0x00,0x00,0x00,0x00},   // 0xC0
{0x08,0x08,0x08,0x3F,0x00,0x00,0x00,0x00},   // 0xC1
{0x00,0x00,0x00,0x3F,0x08,0x08,0x08,0x08},   // 0xC2
{0x08,0x08,0x08,0x38,0x08,0x08,0x08,0x08},   // 0xC3
{0x00,0x00,0x00,0x3F,0x00,0x00,0x00,0x00},   // 0xC4
{0x08,0x08,0x08,0x3F,0x08,0x08,0x08,0x08},   // 0xC5
{0x28,0x14,0x1C,0x20,0x3C,0x22,0x3C,0x00},   // 0xC6
{0x28,0x14,0x08,0x14,0x22,0x3E,0x22,0x00},   // 0xC7
{0x0A,0x3A,0x02,0x3E,0x00,0x00,0x00,0x00},   // 0xC8
{0x00,0x3E,0x02,0x3A,0x0A,0x0A,0x0A,0x0A},   // 0xC9
{0x0A,0x3B,0x00,0x3F,0x00,0x00,0x00,0x00},   // 0xCA
{0x00,0x3F,0x00,0x3B,0x0A,0x0A,0x0A,0x0A},   // 0xCB
{0x0A,0x3A,0x02,0x3A,0x0A,0x0A,0x0A,0x0A},   // 0xCC
{0x00,0x3F,0x00,0x3F,0x00,0x00,0x00,0x00},   // 0xCD
{0x0A,0x3B,0x00,0x3B,0x0A,0x0A,0x0A,0x0A},   // 0xCE
{0x22,0x1C,0x22,0x22,0x22,0x1C,0x22,0x00},   // 0xCF
{0x0C,0x02,0x04,0x08,0x1C,0x12,0x0C,0x00},   // 0xD0
{0x1C,0x24,0x24,0x2E,0x24,0x24,0x1C,0x00},   // 0xD1
{0x1C,0x00,0x3E,0x02,0x1E,0x02,0x3E,0x00},   // 0xD2
{0x14,0x00,0x3E,0x02,0x1E,0x02,0x3E,0x00},   // 0xD3
{0x0C,0x00,0x3E,0x02,0x1E,0x02,0x3E,0x00},   // 0xD4
{0x08,0x08,0x08,0x00,0x00,0x00,0x00,0x00},   // 0xD5
{0x18,0x00,0x1C,0x08,0x08,0x08,0x1C,0x00},   // 0xD6
{0x1C,0x00,0x1C,0x08,0x08,0x08,0x1C,0x00},   // 0xD7
{0x14,0x00,0x1C,0x08,0x08,0x08,0x1C,0x00},   // 0xD8
{0x08,0x08,0x08,0x0F,0x00,0x00,0x00,0x00},   // 0xD9
{0x00,0x00,0x00,0x38,0x08,0x08,0x08,0x08},   // 0xDA
{0x3F,0x3F,0x3F,0x3F,0x3F,0x3F,0x3F,0x3F},   // 0xDB
{0x00,0x00,0x00,0x00,0x3F,0x3F,0x3F,0x3F},   // 0xDC
{0x08,0x08,0x08,0x00,0x08,0x08,0x08,0x00},   // 0xDD
{0x0C,0x00,0x1C,0x08,0x08,0x08,0x1C,0x00},   // 0xDE
{0x3F,0x3F,0x3F,0x3F,0x00,0x00,0x00,0x00},   // 0xDF
{0x18,0x0C,0x12,0x12,0x12,0x12,0x0C,0x00},   // 0xE0
{0x00,0x0E,0x12,0x0E,0x12,0x12,0x0E,0x02},   // 0xE1
{0x1C,0x0C,0x12,0x12,0x12,0x12,0x0C,0x00},   // 0xE2
{0x06,0x0C,0x12,0x12,0x12,0x12,0x0C,0x00},   // 0xE3
{0x14,0x0A,0x00,0x0C,0x12,0x12,0x0C,0x00},   // 0xE4
{0x14,0x0A,0x0C,0x12,0x12,0x12,0x0C,0x00},   // 0xE5
{0x00,0x00,0x12,0x12,0x12,0x0E,0x02,0x02},   // 0xE6
{0x00,0x06,0x02,0x0E,0x12,0x0E,0x02,0x06},   // 0xE7
{0x06,0x02,0x0E,0x12,0x12,0x0E,0x02,0x06},   // 0xE8
{0x18,0x00,0x12,0x12,0x12,0x12,0x0C,0x00},   // 0xE9
{0x1C,0x00,0x12,0x12,0x12,0x12,0x0C,0x00},   // 0xEA
{0x06,0x00,0x12,0x12,0x12,0x12,0x0C,0x00},   // 0xEB
{0x18,0x00,0x12,0x12,0x12,0x1C,0x08,0x06},   // 0xEC
{0x18,0x00,0x22,0x14,0x08,0x08,0x08,0x00},   // 0xED
{0x00,0x1C,0x00,0x00,0x00,0x00,0x00,0x00},   // 0xEE
{0x0C,0x0C,0x04,0x00,0x00,0x00,0x00,0x00},   // 0xEF
{0x00,0x00,0x00,0x1C,0x00,0x00,0x00,0x00},   // 0xF0
{0x00,0x08,0x1C,0x08,0x00,0x1C,0x00,0x00},   // 0xF1
{0x00,0x00,0x3E,0x00,0x00,0x3E,0x00,0x00},   // 0xF2
{0x03,0x16,0x0B,0x34,0x2A,0x38,0x20,0x00},   // 0xF3
{0x3C,0x2A,0x2A,0x2C,0x28,0x28,0x28,0x00},   // 0xF4
{0x1C,0x22,0x0C,0x14,0x18,0x22,0x1C,0x00},   // 0xF5
{0x00,0x08,0x00,0x3E,0x00,0x08,0x00,0x00},   // 0xF6
{0x00,0x00,0x00,0x1C,0x18,0x00,0x00,0x00},   // 0xF7
{0x0C,0x12,0x12,0x0C,0x00,0x00,0x00,0x00},   // 0xF8
{0x00,0x00,0x00,0x14,0x00,0x00,0x00,0x00},   // 0xF9
{0x00,0x00,0x00,0x04,0x00,0x00,0x00,0x00},   // 0xFA
{0x04,0x06,0x04,0x04,0x00,0x00,0x00,0x00},   // 0xFB
{0x0E,0x04,0x0C,0x06,0x00,0x00,0x00,0x00},   // 0xFC
{0x06,0x08,0x04,0x0E,0x00,0x00,0x00,0x00},   // 0xFD
{0x00,0x00,0x1E,0x1E,0x1E,0x1E,0x00,0x00},   // 0xFE
{0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00}    // 0xFF
};
#endif


#ifdef USE_FONT_6X8
   const UG_FONT FONT_6X8 = {(unsigned char*)font_6x8,FONT_TYPE_1BPP,6,8,0,255,0};
#endif
